<?php

/**
* @version $Id: dt.deleteme.php 1.3
* @package Community Builder
* @subpackage DT Delete Me Plugin
* @author DTH Development
* @url www.DTHDevelopment.com
* @copyright (C)2009 DTH Development
* @license http://www.gnu.org/licenses/old-licenses/gpl-2.0.html GNU/GPL version 2
*/

/*
 * TODO LIST
 * - make the delete available also for non-logged in users
 * - send an email to confirm the delete, and set up a timeout (2 days) to delete request
 * hint: http://www.jensbits.com/2009/08/10/modal-confirmation-dialog-on-form-submit-javascript-jquery-ui-and-thickbox-varieties/
 */

// ensure this file is being included by a parent file

if ( ! ( defined( '_VALID_CB' ) || defined( '_JEXEC' ) || defined( '_VALID_MOS' ) ) )
{
	die( 'Direct Access to this location is not allowed.' ); 
}

// accesso dall'esterno:
//http://www.agescirimini.it/index.php?option=com_comprofiler&Itemid=40&task=del

// cb use custom method to load jquery-ui
/*JPluginHelper::importPlugin( 'corejoomla' );
$dispatcher =& JDispatcher::getInstance();
//$params = array('jquery','jqueryui','jqueryform','jqueryvalidate');
$params = array('jqueryui');
$dispatcher->trigger('onCallIncludeJQuery', array($params));*/


require_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_comprofiler' . DS . 'plugin.foundation.php');

//global $_CB_framework, $_CB_database, $ueConfig;
/*$params = $this->params;
global $_CB_framework;*/



class getDeleteMeTab extends cbTabHandler
{
	//var_export( $ _POST );		//DEBUG!
	
	function _getLanguageFile() {
		global $mainframe,$mosConfig_lang;
		$UElanguagePath=$mainframe->getCfg( 'absolute_path' ).'/components/com_comprofiler/plugin/user/plug_deleteme';
		if (file_exists($UElanguagePath.'/language/'.$mosConfig_lang.'.php')) {
			include_once($UElanguagePath.'/language/'.$mosConfig_lang.'.php');
		} else include_once($UElanguagePath.'/language/english.php');
	}
	
	
	function getAuthorTab()
	{
		$this->cbTabHandler();
	}

	function getDisplayTab($tab,$user,$ui)
	{
		
		global $_CB_framework, $_CB_database, $ueConfig;
		$params = $this->params;
		
		$_CB_framework->addJQueryPlugin('ui-all',true);
		//$_CB_framework->document->addHeadScriptUrl($uri->root() . "my_script.js");
		$_CB_framework->outputCbJQuery(' ');
		
		$this->_getLanguageFile();

		$submitName=$params->get('deleteme_dialog_submit',"");
		$cancelName=$params->get('deleteme_dialog_cancel',"");

		$js = '
		// jQuery UI Dialog   
		
		jQuery(\'#dialogDeleteMe\').dialog({
		autoOpen: false,
		width: 400,
		modal: true,
		resizable: false,
		buttons: {
			"' . $submitName . '": function() {
				document.deleteme.submit();
				},
			"' . $cancelName . '": function() {
				$(this).dialog("close");
				}
			}
		});

		jQuery(\'form#deleteme\').submit(function(e){
			e.preventDefault();
		
			jQuery(\'#dialogDeleteMe\').dialog(\'open\');
		});';

		$_CB_framework->outputCbJQuery($js);
		
		
		$myuser =& JFactory::getUser();
		if($myuser->id != $user->id)
		{
		   return "";
		}
		//$user = $my ;
		$id=$myuser->id;
		$taskS	= $_CB_framework->getRequestVar( 'task' );
		
		   switch ( $taskS )
		   {
			case "del":
					global $mainframe;
					
					//perform the logout action
					new cbTabs( 0, 2, null, false );		// load plugins
					$obj =& $_CB_framework->_getCmsUserObject( (int) $id );
					
					$count = 2;

					if ( ( $obj !== null ) && ( $obj->gid == 25 ) )
					{
						// count number of active super admins
						
						$query = "SELECT COUNT( id )"
						. "\n FROM #__users"
						. "\n WHERE gid = 25"
						. "\n AND block = 0";
						
						$_CB_database->setQuery( $query );
						
						$count = $_CB_database->loadResult();
					}

					if ( $count <= 1 && $obj->gid == 25 )
					{
						// cannot delete Super Admin where it is the only one that exists
						
						$msg .= "You cannot delete this Super Administrator as it is the only active Super Administrator for your site";
					}
					else
					{
						// delete user
						// Daniele 2011/10/10: decommentare per renderla funzionante.
						//$result = cbDeleteUser( $id, null, $inComprofilerOnly );
						
						$mailfrom = $ueConfig['reg_email_from'];
						$fromname = $ueConfig['reg_email_name'];
						$mailTo=$ueConfig['reg_email_replyto'];
						$msgUser=$params->get('user_email_text',"");
						$msgAdmin="User {$user->username} with email {$user->email} has successfully deleted themself.";
						$msgSubUser=$params->get('user_email_sub',"");
						$msgSubAdmin="User Account Deleted";
							JUtility::sendMail($mailfrom, $fromname, $user->email, $msgSubUser, $msgUser);
							JUtility::sendMail($mailfrom, $fromname, $mailTo, $msgSubAdmin, $msgAdmin);

							if ( $result === null )
							{
							$msg .= "User not found";
							}
							elseif (is_string( $result ) && ( $result != "" ) )
							{
								$msg .= $result;
						}
					}
					
					//Daniele 2011/10/10, rimosso per test
					//$error = $mainframe->logout();
					
					if(!JError::isError($error))
					{
						if ($return = JRequest::getVar('return', '', 'method', 'base64'))
						{
							$return = base64_decode($return);

							if (!JURI::isInternal($return))
							{
								$return = '';
							}

						}

						if ( $return && !( strpos( $return, 'index.php' )) )
						{

						}

						if ( ! $_CB_framework->check_acl( 'canManageUsers', $_CB_framework->myUserType() ) )
						{
							cbRedirect( 'index.php', _UE_NOT_AUTHORIZED, 'error' );
						}

					}
					else
					{
						parent::display();

					}
				
				break;

		       default:
			       	$buttonName=$params->get('deleteme_button_name',"");
			       	$dialogTitle=$params->get('deleteme_dialog_title',"");
			       	$dialogWarn=$params->get('deleteme_dialog_warn',"");
			       	$dialogBody=$params->get('deleteme_dialog_body',"");
				$return="<div style=\"paading-bottom:40px;\">".$params->get('text_for_frontend',"")."</div>";
				$return.="<form id='deleteme' name='deleteme' method='post' action='#'><input type='submit' value='$buttonName'><input type='hidden' name='task' value='del'></form>\n";
				$return.='<div id="dialogDeleteMe" title="' . $dialogTitle . '">
<p><span class="ui-icon ui-icon-alert" style="float:left; margin:0 7px 0 0;"></span>' . $dialogWarn . '</p>' . $dialogBody . '</div>';
				return $return;
				break;

			}

	}
	
	function del()
	{
		
	}

}
// end class getAuthorTab.

?>
